; -----------------------------------------------------------------------------
; __          ___       ____ ___
; \ \        / (_)     |___ \__ \   RetroForth for Windows
;  \ \  /\  / / _ _ __   __) | ) |  http://www.retroforth.org
;   \ \/  \/ / | | '_ \ |__ < / /
;    \  /\  /  | | | | |___) / /_
;     \/  \/   |_|_| |_|____/____|
; -----------------------------------------------------------------------------

format PE console
stack 16000
entry _start	; entry point of the executable

include "macros.fasm"
include "windows-include/win32a.inc"

section ".code" code readable writeable executable
_start:
	call init_drivers
	call init_retroforth
	call interpret
;---------------------------------------------------------------------
init_drivers:
	invoke GetModuleHandle, 0
	mov [hinstance], eax

	invoke GetStdHandle, STD_INPUT_HANDLE
	mov [StdIn], eax
	invoke SetConsoleMode, eax, 5

	invoke GetStdHandle, STD_OUTPUT_HANDLE
	mov [StdOut], eax

	invoke SetConsoleTitle, "RetroForth"
	ret
;---------------------------------------------------------------------
code 'bye', windows_bye
	invoke ExitProcess,0	; goodbye!!!
code 'emit', emit
	pusha
	mov [emit_buffer], eax	; keep it safe
	invoke WriteConsole, [StdOut], emit_buffer, 1, 0, 0
	popa
	drop
	ret
code 'key', key
	dup
	pusha
	invoke ReadConsole, [StdIn], emit_buffer, 1, written_buffer, 0
	popa
	mov eax, [emit_buffer]
	ret
;---------------------------------------------------------------------
hinstance rd 1
StdIn rd 1
StdOut rd 1
emit_buffer rd 1
written_buffer rd 1
;---------------------------------------------------------------------

; windows-specific linkage stuff:
section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL'

  import kernel,\
	 GetModuleHandle,'GetModuleHandleA',\
	 ExitProcess,'ExitProcess',\
	 GetStdHandle, 'GetStdHandle',\
	 WriteFile, 'WriteFile',\
	 ReadFile, 'ReadFile',\
	 ReadConsole, 'ReadConsoleA',\
	 WriteConsole, 'WriteConsoleA',\
	 SetConsoleMode, 'SetConsoleMode',\
	 SetConsoleTitle, 'SetConsoleTitleA',\
	 CreateFile, 'CreateFileA',\
	 GetLastError,'GetLastError',\
	 CloseHandle,'CloseHandle'


section '.rsrc' resource data readable

  ; resource directory

  directory RT_VERSION,versions

  resource versions,\
	   1,LANG_NEUTRAL,version_info
version \
version_info,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','RetroForth For Windows',\
	  'LegalCopyright','Released into the public domain',\
	  'FileVersion','7.00',\
	  'ProductVersion','7.00',\
	  'OriginalFilename','windows-console.exe',\
	  'Credits',"This port originally written by Ron Aaron"
;---------------------------------------------------------------------
include "retroforth.asm"
